"(FileStream readOnlyFileNamed: 'runTests.st') fileIn."

| initials results report |

report := (FileStream forceNewFileNamed: 'report.txt').

[
	initials := Utilities authorInitialsPerSe.
	Utilities setAuthorInitials:'testServer'.

	[ 
		results := BooleanTest suite run .

		report nextPutAll: SmalltalkImage current systemInformationString withCRs; cr.
		report nextPutAll: 'Time: '; nextPutAll: DateAndTime now asString; cr; cr.

		report nextPutAll: 'Run: '; nextPutAll: results runCount asString; cr.
		report nextPutAll: 'Expected passes: '; nextPutAll: results expectedPassCount asString; cr.
		report nextPutAll: '------------------------------'; cr.
		report nextPutAll: 'Expected failures: '; nextPutAll: results expectedDefectCount asString; cr.
		results expectedDefects do: [:each |
			report tab; nextPutAll: each asString; cr ].
		report nextPutAll: '------------------------------'; cr.
		report nextPutAll: 'Unexpected failures: '; nextPutAll: results unexpectedFailureCount asString; cr.
		results unexpectedFailures do: [:each |
			report tab; nextPutAll: each asString; cr ].
		report nextPutAll: '------------------------------'; cr.
		report nextPutAll: 'Errors: '; nextPutAll: results unexpectedErrors size asString; cr.
		results unexpectedErrors do: [:each |
			report tab; nextPutAll: each asString; cr ].
		report nextPutAll: '------------------------------'; cr.
		report nextPutAll: 'Unexpected passes: '; nextPutAll: results unexpectedPasses size asString; cr.
		results unexpectedPasses do: [:each |
			report tab; nextPutAll: each asString; cr ].
	] on: Error do:  [:e | 
		report cr; nextPutAll: 'INTERNAL ERROR'; cr.
		report nextPutAll: e asString; cr; cr.
		thisContext stack copy withIndexDo: [:stck :i |
			[report nextPutAll: i asString; space; nextPutAll: stck asString; cr] ifError: []].
	].

	Utilities setAuthorInitials: initials.

] ensure: [ report close ].

SmalltalkImage current snapshot: false andQuit: true.